<script lang="ts">
  import Deck from "./lib/Deck.svelte";
  import { GameState, Phase, PrivateState } from "./lib/domain";
  import PhaseDescription from "./lib/PhaseDescription.svelte";
  import Player from "./lib/Player.svelte";
  import PlayersInline from "./lib/PlayersInline.svelte";
  import ScoreTable from "./lib/ScoreTable.svelte";
  import { createActionDispatcher } from "./lib/utils";

  let dispatchAction = createActionDispatcher();

  export let publicState: Server.PublicState;
  export let privateState: Server.PrivateState | null;
  export let playerId: PlayerId | null;

  $: game = GameState.fromPublicState(publicState);
  $: user = privateState && PrivateState.fromServer(privateState);

  $: playerOrder = game.playerOrder(playerId);

  function getPlayerPosition(
    playerCount: number,
    playerIdx: number
  ): { x: number; y: number } {
    const startAngle = -(Math.PI / 2);
    const angleStep = -(2 * Math.PI) / playerCount;
    const angle = startAngle + playerIdx * angleStep;

    return { x: Math.cos(angle) * 30, y: -(Math.sin(angle) * 20) };
  }
</script>

<div class="game">
  <div class="phase-description">
    <PhaseDescription {game} />
  </div>
  <div class="deck">
    <span class="deck-icon">
      <Deck size={game.deckSize()} />
    </span>
    {" "}
    <span class="deck-card-count"> &times; {game.deckSize()} </span>
  </div>
  <ul class="players">
    {#each game.players() as player, idx (player.id())}
      {@const playerState = game.players()[idx]}

      {@const playerPos = getPlayerPosition(
        playerOrder.length,
        playerOrder.indexOf(player.id())
      )}
      <div
        class="player"
        class:user={player.id() === playerId}
        style:--player-translate-x={playerPos.x + "rem"}
        style:--player-translate-y={playerPos.y + "rem"}
      >
        <Player
          {game}
          user={player.id() === playerId ? user : null}
          player={playerState}
          on:action
        />
      </div>
    {/each}
  </ul>
  {#if game.phase() === Phase.RoundEnd}
    <div class="round-end panel">
      <h2>Round is over</h2>

      <div>
        <ScoreTable {game} />
      </div>

      <p>
        <strong>Another round is starting.</strong>
      </p>
      <p>
        {#if playerId !== null && game.isPlayerActive(playerId)}
          <button
            class="primary"
            on:click={() => dispatchAction({ k: "Ready" })}
          >
            I'm ready!
          </button>
        {:else if playerId !== null}
          <em>Waiting for other players &hellip;</em>
        {/if}
      </p>
    </div>
  {:else if game.phase() === Phase.GameEnd}
    <div class="game-end panel">
      <h2>
        <PlayersInline playerIds={game.winners()} />
        {#if game.winners().length > 1}
          win!
        {:else}
          wins!
        {/if}
      </h2>
      <div>
        <ScoreTable {game} />
      </div>
    </div>
  {/if}
</div>

<style>
  .game {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  .phase-description {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) translateY(-50%) translateY(-1rem);
    width: 20em;
    text-align: center;
  }
  .deck {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) translateY(50%) translateY(1rem);

    white-space: nowrap;
    display: flex;
    flex-direction: row;
    align-items: center;
  }

  .deck-icon {
    font-size: 25%;
    display: inline-block;
  }
  .deck-card-count {
    font-size: 2rem;
    margin-left: 0.5em;
  }

  .players {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  .player {
    --player-translate-x: 0;
    --player-translate-y: 0;

    position: absolute;
    top: 50%;
    left: 50%;
    transition: transform 0.25s;
    transform: translate(-50%, -50%) translateX(var(--player-translate-x))
      translateY(var(--player-translate-y));

    padding-top: 5rem;
    padding-bottom: 5rem;
  }
  .player.user {
    padding-top: 8rem;
  }

  .round-end {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);

    text-align: center;
  }
  .round-end > * {
    margin: 1rem;
  }

  em {
    font-weight: 300;
  }

  .game-end {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);

    text-align: center;
  }
  .game-end > * {
    margin: 2rem 1rem;
  }
</style>
